//==============================================================
// ʍ֘A
// STEAR 2009
//--------------------------------------------------------------

#include <string.h>
#include <psputils.h>
#include <pspgu.h>
#include "intraFont.h"
#include "draw.h"
#include "zenkaku.h"
#include "graphics.h"

static unsigned int __attribute__((aligned(16))) gList[1000];

typedef struct
{
	unsigned short u, v;
	short x, y, z;
} Vertex;

//==============================================================
// ̍
//--------------------------------------------------------------

void HLine(int x,int y,int wx,long cor)
{
	int i;

	for (i=0; i<wx ;i++)
		VRAM[y][x+i] = cor;
}

//==============================================================
// c̍
//--------------------------------------------------------------

void VLine(int x,int y,int wy,long cor)
{
	int i;

	for (i=0; i<wy ;i++)
		VRAM[y+i][x] = cor;
}

//==============================================================
// BOX̍
//--------------------------------------------------------------

void Box(int x,int y,int wx,int wy,long corFrame)
{
	HLine(x       ,y       ,wx,corFrame);
	VLine(x       ,y       ,wy,corFrame);
	VLine(x + wx-1,y       ,wy,corFrame);
	HLine(x       ,y + wy-1,wx,corFrame);
}

//==============================================================
// hԂꂽBOX̍
//--------------------------------------------------------------
// ŏ̂PCڂCPUō悵Ac̕GUɂPCڂRs[A
// Ƃ@gĂ܂B
// ̂قCPUōs葁ۂB
//--------------------------------------------------------------

void Fill(int x,int y,int wx,int wy,long corIn)
{
	if (wx==0 || wy==0) return;
	HLine(x,y,wx,corIn);
	if (wy>1){
		sceGuStart(GU_DIRECT,gList);
		sceGuCopyImage(GU_PSM_8888, x,y,wx,wy-1,512,VRAM, x,y+1,512,VRAM);
		sceGuFinish();
		sceGuSync(0,0);
	}
}

//==============================================================
// hԂꂽBOX̍igj
//--------------------------------------------------------------

void BoxFill(int x,int y,int wx,int wy,long corFrame,long corIn)
{
	Fill(x ,y ,wx ,wy ,corIn);
	Box(x ,y ,wx ,wy ,corFrame);
}

//==============================================================
// wi]BOX̍
//--------------------------------------------------------------

void XFill(int x,int y,int wx,int wy,long corIn)
{
	int i,j;

	for (i=0; i<wy ;i++)
		for (j=0; j<wx ;j++)
			VRAM[y+i][x+j] ^= corIn;
}

//==============================================================
// pۂBOX̍igj
//--------------------------------------------------------------
// type  Fpۂ̑傫i0: ` 3:傫 , 4`5:Of[Vj
// corFrmFg̐F
// corIn F̐F
//---------------------------------------------------------------
// Of[Vp^[̏ꍇcorFrm̎w͖AcorInɖ邳
// ς悵܂B
// ܂AOf[Vp^[ł̍掞͓ߏs܂B
//--------------------------------------------------------------

static void CurveBoxSub(int x,int y,int wx,long corFrm,long corIn)
{
	VRAM[y][x] = corFrm;
	HLine(x+1 ,y ,wx-2 ,corIn);
	VRAM[y][x+wx-1] = corFrm;
}

static long CurveBoxCorSet(int ar,long cor,int Alpha)
{
	unsigned long	cor1,cor2,cor3;

	cor1 = ((cor & 0x0000FF) * ar /128);
	if (cor1>0x0000FF) cor1 = 0x0000FF;
	cor2 = ((cor & 0x00FF00) * ar /128);
	if (cor2>0x00FF00) cor2 = 0x00FF00;
	cor3 = ((cor & 0x0FF0000) * ar /128);
	if (cor3>0x0FF0000) cor3 = 0x0FF0000;
	if (Alpha>0xFF) Alpha = 0xFF;
	return ( Alpha<<24 | cor1 | cor2 | cor3 );
}

static void CurveBoxSub2(int x,int y,int wx,int type,int no,long corIn,Image *source,int Alpha)
{
	const int	map1[2][7][6] = {{								// p̃p^[
					{ 0x00,0x00,0x00,0x00,0x00,0x70 },
					{ 0x00,0x00,0x00,0x00,0xFF,0xFF },
					{ 0x00,0x00,0x00,0xFF,0xD0,0xD0 },
					{ 0x00,0x00,0xFF,0xD0,0xB0,0xB0 },
					{ 0x00,0xFF,0xD0,0xB0,0x90,0x90 },
					{ 0x70,0xFF,0xD0,0xB0,0x90,0x80 },
					{ 0xFF,0xD0,0xB0,0x90,0x80,0x80 },
				},{
					{ 0x00,0x00,0x00,0x00,0x00,0x70 },
					{ 0x00,0x00,0x00,0x00,0xFF,0xFF },
					{ 0x00,0x00,0x00,0xFF,0x40,0x40 },
					{ 0x00,0x00,0xFF,0x40,0x50,0x50 },
					{ 0x00,0xFF,0x40,0x50,0x60,0x60 },
					{ 0x70,0xFF,0x40,0x50,0x60,0x70 },
					{ 0xFF,0x40,0x50,0x60,0x70,0x80 },
				}},
				map2[2][7] = {									// g̃o^[
					{ 0xFF,0xD0,0xB0,0x90,0x80,0x80,0x80 },
					{ 0xFF,0x40,0x50,0x60,0x70,0x80,0x80 },
				};
	int	i;

	if (no>5) no = 6;
	if (type>1) type = 1;

	for (i=0; i<6 ;i++){
		if (map1[type][no][i])
			source->data[y*(source->textureWidth)+i] = CurveBoxCorSet( map1[type][no][i],corIn,Alpha );
	}
	for (i=0; i<wx-12 ;i++)
		source->data[y*(source->textureWidth)+6+i] = CurveBoxCorSet( map2[type][no],corIn,Alpha );
	for (i=0; i<6 ;i++){
		if (map1[type][no][5-i])
			source->data[y*(source->textureWidth)+wx-6+i] = CurveBoxCorSet( map1[type][no][5-i],corIn,Alpha );
	}
}

void CurveBox(int x,int y,int wx,int wy,int type,long corFrm,long corIn)
{
	const int	rx[4][4] = {
					{1,0,0,0},
					{2,1,0,0},
					{3,2,1,0},
					{4,2,1,1}
				};
	Image		*source;
	int			i;


	if (type>3){
		sceGuStart(GU_DIRECT,gList);
		sceGuTexMode(GU_PSM_8888, 0, 0, 0);						// ȗintraFontgpɕ\܂
		sceGuFinish();
		source = createImage(wx,wy);
		type -= 4;
		for (i=0; i<wy ;i++){
			if (i<6){
				CurveBoxSub2( x ,i ,wx ,type ,i ,corIn ,source ,0xE0 );
			} else if (i>=wy-6){
				CurveBoxSub2( x ,i ,wx ,type ,wy -1 - i ,corIn ,source ,0xE0 );
			} else {
				CurveBoxSub2( x ,i ,wx ,type ,6 ,corIn ,source ,0xE0 );
			}
		}
		blitAlphaImageToScreen( 0, 0, wx, wy, source, x, y );
		freeImage(source);

	} else {
		for (i=0; i<wy ;i++){
			if (i==0){
				CurveBoxSub(x+rx[type][i] ,y + i ,wx-rx[type][i]*2 ,corFrm ,corFrm);
			} else if (i<4){
				CurveBoxSub(x+rx[type][i] ,y + i ,wx-rx[type][i]*2 ,corFrm ,corIn);
			} else if (i>=wy-1){
				CurveBoxSub(x+rx[type][wy-i-1] ,y + i ,wx-rx[type][wy-i-1]*2 ,corFrm ,corFrm);
			} else if (i>=wy-4){
				CurveBoxSub(x+rx[type][wy-i-1] ,y + i ,wx-rx[type][wy-i-1]*2 ,corFrm ,corIn);
			} else {
				CurveBoxSub(x ,y + i ,wx,corFrm ,corIn);
			}
		}
	}
}

//==============================================================
// ẅ0NA
//--------------------------------------------------------------

void BoxClr(int x,int y,int wx,int wy)
{
	int i;

	for (i=0; i<wy ;i++)
		HLine(x,y + i,wx,0);
}

//==============================================================
// ẅ̃Rs[
//--------------------------------------------------------------
// w肳ꂽ̈bufɎ荞
// buf͗\ߕKv+2mۂĂĂB
//--------------------------------------------------------------

void BoxCopy(long *buf,int x,int y,int wx,int wy)
{
	int i,j;

	buf[0] = wx;
	buf[1] = wy;
	for (i=0; i<wy ;i++)
		for (j=0; j<wx ;j++)
			buf[2+i*wx+j] = VRAM[y+i][x+j];
}

//==============================================================
// ẅ̃y[Xg
//--------------------------------------------------------------
// w肳ꂽʒubufWJB
//--------------------------------------------------------------

void BoxPaste(long *buf,int x,int y)
{
	int i,j;

	for (i=0; i<buf[1] ;i++)
		for (j=0; j<buf[0] ;j++)
			VRAM[y+i][x+j] = buf[2+i*buf[0]+j];
}

//==============================================================
// s̉
//--------------------------------------------------------------
// textsi'\n'j͂čsƍős擾B
//--------------------------------------------------------------

void ChkText(char *text,int *maxLen,int *line)
{
	int	l,p;

	l = 0;
	p = 0;
	*maxLen = 0;
	*line = 0;
	while (1){													// s̊mF
		l++;
		if (text[p]=='\0' || text[p]=='\n'){
			(*line)++;
			if (*maxLen<l){
				*maxLen = l -1;
			}
			l = 0;
		}
		if (text[p]=='\0') break;
		p++;
	}
}

//==============================================================
// s̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
//--------------------------------------------------------------

void DrawText(int x,int y,char *text,long corStr)
{
	char	s,str[128];
	int		p,pos;

	pos = 0;
	while (text[pos]!='\0'){
		p = 0;
		while (1){												// so
			s = text[pos++];
			if (s=='\0'){
				pos--;
				break;
			}
			if (s=='\n') break;
			str[p++] = s;
		}
		str[p] = '\0';
		mh_print(x, y, str, corStr);							// s\
		y += 12 +1;
	}
}

//==============================================================
// bZ[W_CAO̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
//--------------------------------------------------------------

void DiaBox1(int x,int y,char *text,long corStr,long corFrm,long corIn)
{
	int len,wx,wy;

	ChkText( text,&len,&wy );
	wy *= 13;
	wx = len *6;
	CurveBox( x, y, 10+wx+10, 6+wy+5, 4, corFrm, corIn );
	DrawText( x+10, y+6, text, corStr );
}

//==============================================================
// mF_CAO̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
// bZ[W̌0.5s󂯂ăL[KC_X\܂B
//--------------------------------------------------------------

void DiaBox2(int x,int y,char *text,char *key,long corStr,long corKey,long corFrm,long corIn)
{
	int		len,wx,wy;

	ChkText( text,&len,&wy );
	wy *= 13;
	wx = len *6;
	CurveBox( x, y, 10+wx+10, 6+wy+18+5, 4, corFrm, corIn );
	DrawText( x+10, y+6, text, corStr );
	mh_print( x+10+wx/2-strlen(key)*6/2, y+6+wy+6, key, corKey );
}

//==============================================================
// XN[o[̕\icj
//--------------------------------------------------------------
// x,y  XN[o[ʒu
// wy   XN[o[̑傫
// pos  \ʒu
// size \TCY
// max  Ŝ̑傫
// flag 悷邩Hi0:OƓȂ悵Ȃj
//--------------------------------------------------------------

void VRollBar(int x,int y,int wy,long pos,long size,long max,int flag,long corFrm,long corIn,long corBar)
{
	long len,p;
	static long lenBuf = 0,pBuf = 0;

	if (max == 0)
		p = 0;
	else
		p = pos * (wy -2) / max;
	if (max == 0)
		len = wy -2;
	else
		len = (wy -1) * size / max +1;
	if (len > (wy -2)) len = wy -2;								// ʂ͂ݏoꍇ̕␳
	if (p + len > (wy -2)) p = wy -2 - len;						// ʂ͂ݏoꍇ̕␳

	if (lenBuf==len && pBuf==p && flag==0) return;				// OƓȂ悵Ȃ
	lenBuf = len;
	pBuf = p;

	BoxFill(x, y, 5, wy, corFrm, corIn);						// x
	Fill(x+1, y+1+p, 3, len, corBar);							// XN[o[
}

//==============================================================
// ̕\
//--------------------------------------------------------------
// x,y    \Jnʒu
// val    \liT܂Łj
// ztype  擪̋󔒂Ol߂邩i0:Ȃj
// ctype  ̎ށi0:3x5tHg ȊO:SptHgj
// corStr F
// ߂l \IW
//--------------------------------------------------------------

static void sv_print(int x,int y,char c,long corStr)
{
	const int font[10][15] = {{
					1,1,1,
					1,0,1,
					1,0,1,
					1,0,1,
					1,1,1,
				},{
					0,1,0,
					0,1,0,
					0,1,0,
					0,1,0,
					0,1,0,
				},{
					1,1,1,
					0,0,1,
					1,1,1,
					1,0,0,
					1,1,1,
				},{
					1,1,1,
					0,0,1,
					0,1,1,
					0,0,1,
					1,1,1,
				},{
					0,1,0,
					1,1,0,
					1,1,0,
					1,1,1,
					0,1,0,
				},{
					1,1,1,
					1,0,0,
					1,1,1,
					0,0,1,
					1,1,1,
				},{
					1,1,1,
					1,0,0,
					1,1,1,
					1,0,1,
					1,1,1,
				},{
					1,1,1,
					0,0,1,
					0,0,1,
					0,0,1,
					0,0,1,
				},{
					1,1,1,
					1,0,1,
					1,1,1,
					1,0,1,
					1,1,1,
				},{
					1,1,1,
					1,0,1,
					1,1,1,
					0,0,1,
					1,1,1,
				}};
	int i,j;

	if (c==' ') return;
	c -= '0';
	for (i=0; i<5 ;i++)
		for (j=0; j<3 ;j++)
			if (font[(int)c][i*3+j]) VRAM[y+i][x+j] = corStr;
}

static int dvsub(int x,int y,int val,int flag,int ztype,int ctype,long corStr)
{
	static char	zero;
	char		c[2] = {0,0};

	if (flag==0){
		zero = ' ';
	} else if (flag==2){
		zero = '0';
	}

	if (val!=0){												// s'0'󔒂ɕϊ邩
		zero = '0';
		c[0] = '0' + val;
	} else {
		c[0] = zero;
	}
	if (ztype && c[0]==' ') return (x);							// 󔒂̑Ol߂Ȃ
	if (ctype){
		mh_print(x, y, c, corStr);
		return (x+6);
	} else {
		sv_print(x, y, c[0], corStr);
		return (x+4);
	}
}

int DrawVal(int x,int y,long val,int ztype,int ctype,long corStr)
{
	x = dvsub(x, y, (val/10000)%10, 0, ztype, ctype, corStr);
	x = dvsub(x, y, (val/1000 )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/100  )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/10   )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/1    )%10, 2, ztype, ctype, corStr);
	return (x);
}

//==============================================================
// L̕\
//--------------------------------------------------------------

void DrawChar(int x,int y,int code,long corStr)
{
	const int font[][21] = {{
					0,0,0,
					0,0,0,
					1,0,0,
					0,1,1,
					1,0,0,
					0,0,0,
					0,0,0,
				},{
					0,0,0,
					0,1,0,
					0,1,0,
					0,1,0,
					1,1,1,
					0,1,0,
					0,0,0,
				},{
					0,0,1,
					0,1,0,
					0,0,0,
					0,1,0,
					0,0,0,
					0,1,0,
					0,0,1,
				},{
					0,1,0,
					0,0,0,
					0,0,0,
					0,0,0,
					0,0,0,
					0,0,0,
					0,1,0,
				},{
					1,0,0,
					0,1,0,
					0,0,0,
					0,1,0,
					0,0,0,
					0,1,0,
					1,0,0,
				}};
	int i,j;

	for (i=0; i<7 ;i++)
		for (j=0; j<3 ;j++)
			if (font[code][i*3+j]) VRAM[y+i][x+j] = corStr;
}

